/*
 * Copyright (C) 2002-2003 chik, hiranaka
 * 2003-10-10 Some bug related to delete mail is removed by xken.
 * 2003-10-26 Big modification is done for owner draw and etc by xken.
 * 2003-11-05 Some bug related to flicker drawing is removed by minamina.
 * For license terms, see the file COPYING in this directory.
 */

// SummaryView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Pochy.h"
#include "SummaryView.h"
#include "HeaderView.h"
#include "FolderView.h"
#include "MainFrm.h"
#include "CodeConvert.h"
#include "StrTok.h"
#include "MimeDecode.h"
#include "lib.h"
#include "direct.h"			// _mkdir
#include "MemoryDC.h"
#include "_regex.h"
#include "TimeEx.h"
#include "SendMailThreadCmd.h" // [MXbh̃R}hꗗ

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SUMMARYVIEW_FILENAME _T("\\skin\\summaryview.bmp")
#define SUMMARYVIEW_TRANSPARENT_COLOR (RGB(255,255,255))
#define SUMMARYVIEW_ICON_READ (0)		// ǎ̃ACRԍ
#define SUMMARYVIEW_ICON_SELECT (1)		// ĨACRԍ
#define SUMMARYVIEW_ICON_UNREAD (2)		// ǎ̃ACRԍ
#define SUMMARYVIEW_ICON_DELETE (3)		// 폜}[ÑACRԍ
#define SUMMARYVIEW_ICON_ATTACH (4)		// Yt莞̃ACRԍ
#define SUMMARYVIEW_RESICON_W (17)
#define SUMMARYVIEW_RESICON_H (16)
#define SUMMARYVIEW_BACKGROUND_FILENAME _T("\\skin\\SummaryViewBk.bmp")

/////////////////////////////////////////////////////////////////////////////
// CSummaryView

IMPLEMENT_DYNCREATE(CSummaryView, CListView)

CSummaryView::CSummaryView()
{
	this->m_stack_num = 0;
	this->m_status_changed = FALSE;
	this->m_index = -1;

	m_bIconUsed = false;
	m_IconImageHeight = 0;
	m_IconImageWidth = 0;
	m_ReadFontHeight = 16;
	m_UnreadFontHeight = 16;
	m_colReadText = 0;
	m_colReadBk = 0;
	m_colUnreadText = 0;
	m_colUnreadBk = 0;
	m_colSelectText = 0;
	m_colSelectBk = 0;
}

CSummaryView::~CSummaryView()
{
	WriteList();
}

BEGIN_MESSAGE_MAP(CSummaryView, CBitmapListView)
	//{{AFX_MSG_MAP(CSummaryView)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnGetdispinfo)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_WM_KEYDOWN()
	ON_WM_SETFOCUS()
	ON_NOTIFY_REFLECT(LVN_BEGINDRAG, OnBegindrag)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
	ON_WM_LBUTTONUP()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_COMMAND(ID_SUMMARYVIEW_DEL, OnPopupDel)
	ON_COMMAND(ID_SUMMARYVIEW_HEADER_INFO, OnPopupHeaderInfo)
	ON_COMMAND(ID_SUMMARYVIEW_RAWMAIL_INFO, OnPopupRawmailInfo)
	ON_COMMAND(ID_SUMMARYVIEW_REBUILD, OnPopupRebuild)
	ON_WM_KILLFOCUS()
	ON_WM_MEASUREITEM_REFLECT()
	ON_COMMAND(ID_NEXT_MAIL, OnNextMail)
	ON_COMMAND(ID_PREV_MAIL, OnPrevMail)
	ON_COMMAND(ID_NEXT_UNREAD_MAIL, OnNextUnreadMail)
	ON_MESSAGE(SENDMAIL_THREAD_COMMAND, OnSendMailThreadCommand)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSummaryView `

void CSummaryView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// CSummaryView ff

#ifdef _DEBUG
void CSummaryView::AssertValid() const
{
	CListView::AssertValid();
}

void CSummaryView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSummaryView bZ[W nh

void CSummaryView::OnInitialUpdate() 
{
	CListCtrl& lc = GetListCtrl();
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	int i;
	CString num;
	char* Column[] = { _T(""),  _T("TCY"),  _T(""),  _T("ol"),  _T("t") };
	LV_COLUMN lvc;
	DWORD dwStyle;
	HWND hWnd;

	// ݂̃X^CA|[gX^C֕ύX
	hWnd = lc.GetSafeHwnd();
	dwStyle = GetWindowLong(hWnd, GWL_STYLE);
	SetWindowLong(hWnd, GWL_STYLE, (dwStyle &~ LVS_TYPEMASK) | LVS_REPORT);
	lc.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_HEADERDRAGDROP);

	// C[WXg̐ݒ
	ReadIconImage();
	SetIconUsed((app->GetProfileInt(_T("SummaryView"), _T("UseIcon"), 1) ? true : false));

	// F̐ݒ
	COLORREF colDefReadText = RGB(DEF_TXT_COLOR_R, DEF_TXT_COLOR_G, DEF_TXT_COLOR_B);
	COLORREF colDefReadBk = RGB(DEF_BKG_COLOR_R, DEF_BKG_COLOR_G, DEF_BKG_COLOR_B);
	SetReadTextColor(ReadIniColor(_T("TxtColor"), colDefReadText));
	SetReadBkColor(ReadIniColor(_T("BkColor"), colDefReadBk));
	SetUnreadTextColor(ReadIniColor(_T("UnreadTxtColor"), m_colReadText));
	SetUnreadBkColor(ReadIniColor(_T("UnreadBkColor"), m_colReadBk));
	SetSelectTextColor(ReadIniColor(_T("SelectTxtColor"), GetSysColor(COLOR_HIGHLIGHTTEXT)));
	SetSelectBkColor(ReadIniColor(_T("SelectBkColor"), GetSysColor(COLOR_HIGHLIGHT)));

	// tHg̐ݒ
	LOGFONT lf;
	if (ReadIniFont(_T("ReadLogFont"), &lf) == false){
		::GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(LOGFONT), &lf);
	}
	SetReadFont(&lf);
	if (ReadIniFont(_T("UnreadLogFont"), &lf) == false){
		lf.lfWeight += 300;		// {[h
	}
	SetUnreadFont(&lf);

	// Xgr[փJݒ
	lvc.mask = LVCF_FMT|LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
	lvc.fmt = LVCFMT_LEFT;
	for(i = 0; i < 5; i++){
		if (i == 1)
		{
			// TCY͉E
			lvc.fmt = LVCFMT_RIGHT;
		}
		else
		{
			lvc.fmt = LVCFMT_LEFT;
		}
		lvc.pszText = Column[i];
		num.Format("%d", i);
		lvc.cx = app->GetProfileInt(_T("SummaryViewColumn"), num, 100);
		if(lvc.cx > 1000){
			lvc.cx = 100;
		}
		lc.InsertColumn(i, &lvc);
	}

	// T}[r[̃J̏Ԃ ini t@Cݒ
	ReadIniColumnOrder();

	// T}[r[̔wi摜ݒ
//	CString strBackgroundFilePath = app->m_app_path + SUMMARYVIEW_BACKGROUND_FILENAME;
	// skin.ini
	CString strBackgroundFilePath;
	if(app->m_skin.getSummarryViewBackBmp() == ""){
		strBackgroundFilePath = app->m_app_path + SUMMARYVIEW_BACKGROUND_FILENAME;
	}else{
		strBackgroundFilePath = app->m_skin.getSkinIniPath() + "\\" + app->m_skin.getSummarryViewBackBmp();
	}
	SetBkImage(strBackgroundFilePath);

	// Xgr[փf[^i[
	m_index = -1;

	// Xgr[XV
	UpdateSummaryView();
}

void CSummaryView::OnGetdispinfo(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	LV_DISPINFO *pDispInfo = (LV_DISPINFO*)pNMHDR;

	int num = pDispInfo->item.iItem;
	CString buf;
	CTimeEx time;

	if(m_stack_num > 0 && pDispInfo->item.mask & LVIF_TEXT){
		switch(pDispInfo->item.iSubItem){
			case 0:
				buf = m_array_list[m_stack_num-num-1]->m_str6;
				lstrcpy(pDispInfo->item.pszText, buf);
				break;
			case 1:
				buf = m_array_list[m_stack_num-num-1]->m_str1;
				lstrcpy(pDispInfo->item.pszText, buf);
				break;					
			case 2:
				if(m_array_list[m_stack_num-num-1]->m_str2.GetLength() > LISTCTRL_BUF_LENGTH){
					m_array_list[m_stack_num-num-1]->m_str2 = m_array_list[m_stack_num-num-1]->m_str2.Left(LISTCTRL_BUF_LENGTH);
				}
				buf = m_array_list[m_stack_num-num-1]->m_str2;
				lstrcpy(pDispInfo->item.pszText, buf);
				break;
			case 3:
				if(m_array_list[m_stack_num-num-1]->m_str3.GetLength() > LISTCTRL_BUF_LENGTH){
					m_array_list[m_stack_num-num-1]->m_str3 = m_array_list[m_stack_num-num-1]->m_str3.Left(LISTCTRL_BUF_LENGTH);
				}
				buf = m_array_list[m_stack_num-num-1]->m_str3;
				lstrcpy(pDispInfo->item.pszText, buf);
				break;
			case 4:
				buf = m_array_list[m_stack_num-num-1]->m_str4;
				if(!buf.IsEmpty()){
					time.SetTimeT(atol(buf), "+0000");
					time.SetNewOffset(app->m_time_zone_offset);
					buf = time.GetFormatDate(DEF_TIME_FORMAT);
				}
				lstrcpy(pDispInfo->item.pszText, buf);
				break;
		}
	}
	*pResult = 0;
}

BOOL CSummaryView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style	|= LVS_OWNERDATA 
				| LVS_REPORT 
				| LVS_SHOWSELALWAYS
				| LVS_OWNERDRAWFIXED;	// I[i[`
	// LVS_SORTDESCENDING  LVS_SORTASCENDING

	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSummaryView bZ[W nhłȂ֐

int CSummaryView::SetStack(LPCTSTR path)
{
	CString tmp;
	CString message;
	CStrTok StrTok;

	tmp.Format("%s\\list", path);
	CStdioFile ReadFile;
	if(!ReadFile.Open(tmp, CFile::modeRead | CFile::typeText)){
#if 0 // listȂꍇ͂悤ɂ
		message.Format("CSummaryView: cannot open %s\\list", path);
		AfxMessageBox(message);
		return -1;
#else
		tmp.Format("%s\\list", path);
		g_file_create(tmp);
		if(!ReadFile.Open(tmp, CFile::modeRead | CFile::typeText)){
			message.Format("CSummaryView: cannot open %s", tmp);
			AfxMessageBox(message);
			return -1;
		}
#endif
	}
	tmp.Empty();

	// ArrayListɑ
	m_array_list.RemoveAll();
	int n=0;
	while(ReadFile.ReadString(tmp)){
		SLISTSTACK* list = new SLISTSTACK;

		list->m_str1 = StrTok.Tokenize(tmp.GetBuffer(0), "\x02");
		list->m_str2 = StrTok.Tokenize(NULL, "\x02");
		list->m_str3 = StrTok.Tokenize(NULL, "\x02");
		list->m_str4 = StrTok.Tokenize(NULL, "\x02");
		list->m_str5 = StrTok.Tokenize(NULL, "\x02");
		list->m_str6 = StrTok.Tokenize(NULL, "\x02");
		if(-1 != list->m_str6.Find("N")){
			m_unread++;
		}
		list->m_str7 = StrTok.Tokenize(NULL, "\x02");
		list->m_str8 = StrTok.Tokenize(NULL, "\x02");
		list->m_str9 = StrTok.Tokenize(NULL, "\x02");

		n++;
		m_array_list.Add(list);
		tmp.Empty();
	}
	ReadFile.Close();

	SaveUnreadCount(path, m_unread, n);
	return(n);
}

void CSummaryView::SetItem(LPCTSTR path)
{
	CWaitCursor wait_cursor; // turn cursor into sandglass

	WriteList(); // 荇݂̓elistɕۑ
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)this->GetParentFrame();
	CListCtrl& lc = GetListCtrl();
	SelectItem(-1);
	m_path = path; // ݕ\悤ƂĂlistt@ĈtH_̃pXm_pathɕۑ
	m_unread = 0;

	CString current_account = mf->m_pAcntV->GetCurrentAccountName();

	// Xgr[̃J̕init@C֕ۑ
	CString num;
	for(int i = 0; i < 5; i++){
		num.Format("%d", i);
		app->WriteProfileInt("SummaryViewColumn", num, lc.GetColumnWidth(i));
	}

	// T}[r[̃J̏Ԃ ini t@C֕ۑ
	WriteIniColumnOrder();

	// listview̃RKvɉĕύX
	if(path == app->m_app_path+"\\"+current_account+"\\outbox"
		|| path == app->m_app_path+"\\"+current_account+"\\draft")
		this->UpdateColumn(SMRY_COLUMN_TO);
	else
		this->UpdateColumn(SMRY_COLUMN_FROM);

	m_stack_num = SetStack(path);

	CString unread;
	unread.Format(" %d  [ %d", m_unread, m_stack_num);
	mf->SetStatusBarText(2, unread);

	SortWithRequiredCheck();

	m_index = -1; // IĂȂ
	if(m_stack_num != -1)
		lc.SetItemCountEx(m_stack_num, LVSICF_NOINVALIDATEALL);
}

void CSummaryView::AddList(SLISTSTACK *pList)
{
	CListCtrl& lc = GetListCtrl();
	m_stack_num++;
	m_array_list.Add(pList);
	lc.InsertItem(0, pList->m_str1); // I[i[h[Ȃ̂ŃTuACeOnGetdispinfoŏ
	if(m_index != -1)
		m_index++;
}

BOOL CSummaryView::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult)
{
	if(message == WM_NOTIFY){
		NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)lParam;

		// ʂ̃ACeIꂽɌĂ΂
		if( pNMListView->hdr.code == LVN_ITEMCHANGED && pNMListView->uNewState == 3 &&
			m_index != pNMListView->iItem )
		{
			CPochyApp* app = (CPochyApp*)AfxGetApp();
			CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
			CTextView *tv = (CTextView*)mf->m_pTextV;
			m_index = pNMListView->iItem;

			BOOL b = ClearStatus(m_index);
			m_status_changed |= b;
			if(b){
				CString unread;
				unread.Format(" %d  [ %d", --m_unread, m_stack_num);
				mf->SetStatusBarText(2, unread);
				SaveUnreadCount(m_path, m_unread, m_stack_num);
				RedrawUnreadCount();
			}

			// mainframe̊e{^Lɂ
			mf->UpdateButton2(TRUE);

			tv->Update(m_path + "\\" + m_array_list[m_stack_num-m_index-1]->m_str5);

			*pLResult = 0;
		}
	}
	return CListView::OnChildNotify(message, wParam, lParam, pLResult);
}

void CSummaryView::UpdateColumn(int flag)
{
	CListCtrl& lc = this->GetListCtrl();
	CPochyApp *app = (CPochyApp *)AfxGetApp();

	CString num;
	LV_COLUMN lvc;
	char* Column1[] = { "", "TCY", "", "ol", "t" };
	char* Column2[] = { "", "TCY", "", "", "t" };

	lvc.mask = LVCF_FMT|LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;

	int i;
	for(i = 0; i < 5; i++) lc.DeleteColumn(0);

	if(flag == SMRY_COLUMN_FROM){
		for(i = 0; i < 5; i++){
			if (i == 1)
			{
				// TCY͉E
				lvc.fmt = LVCFMT_RIGHT;
			}
			else
			{
				lvc.fmt = LVCFMT_LEFT;
			}
			lvc.pszText = Column1[i];
			num.Format("%d", i);
			lvc.cx = app->GetProfileInt("SummaryViewColumn", num, 100);
			lc.InsertColumn(i, &lvc);
		}
	}
	if(flag == SMRY_COLUMN_TO){
		for(i = 0; i < 5; i++){
			if (i == 1)
			{
				// TCY͉E
				lvc.fmt = LVCFMT_RIGHT;
			}
			else
			{
				lvc.fmt = LVCFMT_LEFT;
			}
			lvc.pszText = Column2[i];
			num.Format("%d", i);
			lvc.cx = app->GetProfileInt("SummaryViewColumn", num, 100);
			lc.InsertColumn(i, &lvc);
		}
	}

	// T}[r[̃J̏Ԃ ini t@Cݒ
	ReadIniColumnOrder();

	int status = GetPrivateProfileInt("list", "order", 0, this->m_path+"\\folder.ini");
	this->SetColumnOrderStatus(status);
}

void CSummaryView::SetStatus(int nItem, LPCTSTR status)
{
	if(this->m_index > -1 && this->m_index < m_stack_num){
		this->m_array_list[this->m_stack_num-nItem-1]->m_str6 = status;
		this->GetListCtrl().RedrawItems(nItem,nItem);
	}
}

BOOL CSummaryView::ClearStatus(int nItem)
{
	CString buf;
	buf = this->m_array_list.GetAt(this->m_stack_num-nItem-1)->m_str6;
	if(buf.Left(1)=="N"){
		SetStatus(nItem, " "+buf.Right(1));
		return TRUE;
	}
	return FALSE;
}

BOOL CSummaryView::UnmarkStatus(int nItem)
{
	CString buf;
	buf = this->m_array_list.GetAt(this->m_stack_num-nItem-1)->m_str6;
	if(buf.Left(1)=="D"){
		this->SetStatus(nItem, " "+buf.Right(1));
		return TRUE;
	}
	return FALSE;
}

BOOL CSummaryView::MarkDStatus(int nItem)
{
	CString buf;
	buf = this->m_array_list.GetAt(this->m_stack_num-nItem-1)->m_str6;
	if(buf.Left(1)!="D"){
		this->SetStatus(nItem, "D"+buf.Right(1));
		return TRUE;
	}
	return FALSE;
}

void CSummaryView::SelectNext()
{
	if(this->m_index < m_stack_num -1){
		this->GetListCtrl().SetItemState(this->m_index, (UINT)~(LVIS_SELECTED | LVIS_FOCUSED), LVIS_SELECTED | LVIS_FOCUSED);
		this->GetListCtrl().SetItemState(this->m_index+1, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
		this->GetListCtrl().EnsureVisible(this->m_index, TRUE);
		this->GetListCtrl().RedrawItems(this->m_index, this->m_index);
		this->UpdateWindow();
	}
}

void CSummaryView::SelectPrev()
{
	if(this->m_index > 0){
		this->GetListCtrl().SetItemState(this->m_index, (UINT)~(LVIS_SELECTED | LVIS_FOCUSED), LVIS_SELECTED | LVIS_FOCUSED);
		this->GetListCtrl().SetItemState(this->m_index-1,LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
		this->GetListCtrl().EnsureVisible(this->m_index, TRUE);
		this->GetListCtrl().RedrawItems(this->m_index, this->m_index);
		this->UpdateWindow();
	}
}

void CSummaryView::DeleteMail(CUIntArray &index_array)
{
	if(index_array.GetSize() < 1){
		return;
	}

	CWaitCursor wait_cursor; // turn cursor into sandglass

	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CHeaderView *hv = (CHeaderView*)mf->m_pHeadV;
	CTextView *tv = (CTextView *)mf->m_pTextV;
	CStringArray cstra;

	int i = index_array.GetSize()-1;
	while(i >= 0){
		DeleteFile(m_path+"\\"+m_array_list.GetAt(m_stack_num-index_array.GetAt(i)-1)->m_str5);
		if (m_array_list.GetAt(m_stack_num-index_array.GetAt(i)-1)->m_str6.Find(_T("N")) != -1)
		{
			m_unread--;
		}
		this->m_array_list.RemoveAt(m_stack_num-index_array.GetAt(i)-1);
		this->m_stack_num--;
		i--;
	}

	// something is changed.
	SelectItem(-1);
	this->m_index = -1;
	this->GetListCtrl().SetItemCountEx(m_stack_num, LVSICF_NOSCROLL);
	this->m_status_changed = TRUE;
	this->WriteList();
	hv->Clear();
	tv->Clear();

	CString unread;
	unread.Format(" %d  [ %d", m_unread, m_stack_num);
	mf->SetStatusBarText(2, unread);
	SaveUnreadCount(m_path, m_unread, m_stack_num);
	RedrawUnreadCount();
}

void CSummaryView::WriteList()
{
	if(!m_status_changed)
		return;
	this->m_status_changed = FALSE;

	FILE *file;
	if(!(file = fopen(m_path + "\\list", "wb"))){
		AfxMessageBox("error: fopen in WriteList()");
		return;
	}

	for(int i=0;i<this->m_array_list.GetSize();i++){
		fprintf(file, "%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\r\n",
			m_array_list[i]->m_str1,
			m_array_list[i]->m_str2,
			m_array_list[i]->m_str3,
			m_array_list[i]->m_str4,
			m_array_list[i]->m_str5,
			m_array_list[i]->m_str6,
			m_array_list[i]->m_str7,
			m_array_list[i]->m_str8,
			m_array_list[i]->m_str9);
	}
	fclose(file);
}

void CSummaryView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CWaitCursor wait_cursor; // turn cursor into hourglass
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CFolderView *fv = (CFolderView*)mf->m_pTreeV;
	CString box_name;
	CString current_account = mf->m_pAcntV->GetCurrentAccountName();
//----
	CStringArray body;
	CString message;
	CString out;
	CCodeConvert cc;
//----
	POSITION Pos = this->GetListCtrl().GetFirstSelectedItemPosition();
	int index = (int)Pos-1;

	if((fv->GetSelectedItemKind() == FV_DRAFT ||
		fv->GetSelectedItemKind() == FV_OUTBOX) &&
		index != -1)
	{
		CMimeDecode md;
		if(!md.DoIt(m_path + "\\" + this->m_array_list[m_stack_num-index-1]->m_str5)){
			return;
		}

		app->m_me.Initialize();
		app->m_me.SetTo(md.m_hi.GetTo());
		app->m_me.SetCc(md.m_hi.GetCc());
		app->m_me.SetBcc(md.m_hi.GetBcc());
		app->m_me.SetFrom(md.m_hi.GetFrom());
		app->m_me.SetSubject(md.m_hi.GetSubject());
		app->m_me.SetReplyTo(md.m_hi.GetReplyTo());
		app->m_me.SetMessageID(md.m_hi.GetMsgID());
		app->m_me.SetInReplyTo(md.m_hi.GetInReplyTo());
		if(md.IsPgpMime())
			app->m_me.SetMode(ME_MODE_PGP);
		else
			app->m_me.SetMode(ME_MODE_NONE);

		md.GetBody(0, body);
		g_cstringarray2cstring(body, message);

		if(md.GetFileName(0).IsEmpty()){
			// in case of base64 in text/plain or text/html.
			if(md.GetEncodingType(0) == BASE64){
				message.Remove('\r');
				message.Remove('\n');
				g_decode_base64(message, out);
				message.Empty();
				message = out;
			}
			// in case of quoted-printable in text/plain or text/html
			if(md.GetEncodingType(0) == QUOTED_PRINTABLE){
				g_decode_qp(message, out);
				message.Empty();
				message = out;
			}
			cc.SetString(message);
			message = cc.ToSjis();
		}else{ // in case of attachment file.
			if(md.GetEncodingType(0) == SEVEN_BIT){
				cc.SetString(message);
				message = cc.ToSjis();
			}
			else if(md.GetEncodingType(0) == EIGHT_BIT){
				cc.SetString(message);
				message = cc.ToSjis();
			}else{
				message.Format("Ytt@C\r\n%s", md.GetFileName(0));
			}
		}
		app->m_me.AddText(message);
// --------------
		int max = md.HowManyPart();	
		int i;
		for (i=1;i<max;++i) {
			CString file_name;
			CString extension;
			MULTIPART_STRUCT2 data;
			data.m_content_type = md.GetContentType(i);		
			data.m_content_transfer_encoding=md.GetRawCTE(i);
			data.m_content_disposition = md.GetRawCD(i);
			md.GetBody(i, body);			
			g_cstringarray2cstring(body, data.m_body);
			data.m_encoding_type = md.GetEncodingTypeStr(i);
			data.m_file_name = md.GetFileName(i);
			if (data.m_file_name=="") {
				extension = md.GetExtension(data.m_content_type);
				data.m_file_name.Format("Atache(%d).%s",i,extension);
			}
			data.m_type = md.GetContentType(i);
			app->m_me.AddMultipart(data);
		}

/*
		MULTIPART_STRUCT2 data;
		CString tmp = md.GetContentType(0);
		tmp.MakeLower();
		if(tmp.Find("text/plain") == -1){
			data.m_content_type = "text/plain; charset=ISO-2022-JP";
			app->m_me.AddMultipart(data);
		}
		int i;
		int max = md.HowManyPart();
		for(i=1; i<max; i++){
			CStringArray body;
			CString extension;
			data.m_content_type = md.GetRawCT(i);
			data.m_content_transfer_encoding = md.GetRawCTE(i);
			data.m_content_disposition = md.GetRawCD(i);
			md.GetBody(i, body);
			g_cstringarray2cstring(body, data.m_body);

			switch(md.GetEncodingType(i)){
			case SEVEN_BIT:
				data.m_encoding_type = "7bit";
				break;
			case EIGHT_BIT:
				data.m_encoding_type = "8bit";
				break;
			case BIN:
				data.m_encoding_type = "bin";
				break;
			case BASE64:
				data.m_encoding_type = "base64";
				break;
			case QUOTED_PRINTABLE:
				data.m_encoding_type = "quoted-printable";
				break;
			}
			data.m_file_name = md.GetFileName(i);
			data.m_type = md.GetContentType(i);
			app->m_me.AddMultipart(data);
		}
		*/

		if(fv->GetSelectedItemKind() == FV_DRAFT){
			CUIntArray ia;
			this->GetSelectedMail(ia);
			CString message;
			GetPrivateProfileString(
				"mailbox",
				"draft",
				"",
				box_name.GetBuffer(BUF_LENGTH),
				BUF_LENGTH,
				app->m_app_path+"\\"+current_account+"\\account.ini");
			box_name.ReleaseBuffer();
			if(box_name.IsEmpty()){
				message.Format("%s\r\n\r\n%s폜Ă悢łH",
					this->m_array_list[this->m_stack_num-this->m_index-1]->m_str2,
					DEF_BOXNAME_DRAFT);
			}else{
				message.Format("%s\r\n\r\n%s폜Ă悢łH",
					this->m_array_list[this->m_stack_num-this->m_index-1]->m_str2,
					box_name);
			}
			if(IDYES == AfxMessageBox(message, MB_YESNO)){
				this->DeleteMail(ia);
				mf->UpdateButton2(FALSE);
			}
		}
		app->CreateDraftFrame(mf->m_pAcntV->GetCurrentAccountName());
	}
	*pResult = 0;
}

void CSummaryView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CFolderView *fv = (CFolderView *)mf->m_pTreeV;
//	CAccountView *av = (CAccountView *)mf->m_pAcntV;
	CStringArray cstra;
	CString message;
	CString box_name;
	CUIntArray ia;

	CString current_account = mf->m_pAcntV->GetCurrentAccountName();

	switch(nChar){
		case 46: // if press del key, delete mail
			this->GetSelectedMail(ia);
			if(this->m_index == -1){
				return;
			}
			if(fv->GetSelectedItemKind() != FV_TRASH){
				if(ia.GetSize() == 1){
					GetPrivateProfileString(
						"mailbox",
						"trash",
						"",
						box_name.GetBuffer(BUF_LENGTH),
						BUF_LENGTH,
						app->m_app_path+"\\"+current_account+"\\account.ini");
					box_name.ReleaseBuffer();
					if(box_name.IsEmpty()){
						message.Format("%s\r\n\r\n%sɈڂĂ悢łH",
							this->m_array_list[this->m_stack_num-this->m_index-1]->m_str2,
							DEF_BOXNAME_TRASH);
					}else{
						message.Format("%s\r\n\r\n%sɈڂĂ悢łH",
							this->m_array_list[this->m_stack_num-this->m_index-1]->m_str2,
							box_name);
					}
				}else if(ia.GetSize() > 1){
					GetPrivateProfileString(
						"mailbox",
						"trash",
						"",
						box_name.GetBuffer(BUF_LENGTH),
						BUF_LENGTH,
						app->m_app_path+"\\"+current_account+"\\account.ini");
					box_name.ReleaseBuffer();
					if(box_name.IsEmpty()){
						message.Format("\r\n\r\n%sɈڂĂ悢łH", DEF_BOXNAME_TRASH);
					}else{
						message.Format("\r\n\r\n%sɈڂĂ悢łH", box_name);
					}
				}
				if(IDYES == AfxMessageBox(message, MB_YESNO)){
					this->MoveMail(ia, app->m_app_path+"\\"+current_account+"\\trash", SMRY_COLUMN_FROM);
				}
			}else{
				if(ia.GetSize() == 1){
					message = this->m_array_list[this->m_stack_num-this->m_index-1]->m_str2+"\r\n\r\n폜Ă悢łH";
				}else if(ia.GetSize() > 1){
					message = "\r\n\r\n폜Ă悢łH";
				}
				if(IDYES == AfxMessageBox(message, MB_YESNO)){
					this->DeleteMail(ia);
				}
			}
			// invalidate some button in toolbar.
			mf->UpdateButton2(FALSE);
			break;
		default:
			break;
	}
	CListView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CSummaryView::OnSetFocus(CWnd* pOldWnd) 
{
	CListView::OnSetFocus(pOldWnd);

	// ACeĕ`悵ĕύX\
	if (pOldWnd != NULL && pOldWnd->GetParent() == this) return;
	if ((GetStyle() & LVS_TYPEMASK) == LVS_REPORT) RepaintSelectedItems();
}

void CSummaryView::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	CUIntArray ia;

	CPochyApp* app = (CPochyApp*)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CFolderView* fv = mf->m_pTreeV;
	fv->m_ListItemDrag = pNMListView->iItem;
	fv->m_hitemDrag = NULL;

	POINT pt;
	pt.x = pt.y = 8;
	this->GetSelectedMail(ia);
	if(ia.GetSize() > 1){
		fv->m_drag_image.BeginDrag(1, CPoint(8, 8));
	}else{
		fv->m_drag_image.BeginDrag(0, CPoint(8, 8));
	}
	pt = pNMListView->ptAction;
	ClientToScreen(&pt);
	fv->m_drag_image.DragEnter(NULL, pt);

	fv->m_bLDragging = TRUE;
	fv->m_hitemDrop = NULL;
	fv->SetCapture();

	*pResult = 0;
}

BOOL CSummaryView::SaveMail(LPCTSTR path, CString mail, int mail_status, int what_kind_box)
{
	if(!strlen(path)){
		return FALSE;
	}

	CString header;
	CString subject;
	CString to;
	CString from;
	CString date;
	CString seq;
	CString size;
	CString stat;
	CString message_id;
	CString in_reply_to;
	CString char_set;
	CString tmp;
	CTimeEx time;

	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame *)app->m_pMainWnd;

	// CStringseqԍZbgi[ۑpj
	seq.Format("%d", g_get_min_num(path));

	// [̕ۑ
	tmp.Format("%s\\%s", path, seq);
	CCodeConvert cc(mail);
	mail = cc.ToJis();
	g_string2file(mail, tmp);

	// [TCY̎擾iK[ۑɁj
	size.Format("%d", g_get_file_size(tmp));

	// [wb_odecodeKvȃwb_擾
	CHeaderInfo hi;
	CStringArray cstra;
	header = mail.Left(mail.Find("\r\n\r\n")+strlen("\r\n"));
	g_string2cstringarray(header, cstra, "\r\n", TRUE);
	hi.DoIt(cstra);

	subject = hi.GetSubject();
	if(subject.GetLength() > LISTCTRL_BUF_LENGTH){
		subject = subject.Left(LISTCTRL_BUF_LENGTH);
	}
	to = hi.GetTo();
	if(to.GetLength() > LISTCTRL_BUF_LENGTH){
		to = to.Left(LISTCTRL_BUF_LENGTH);
	}
	from = hi.GetFrom();
	message_id = hi.GetMsgID();
	in_reply_to = hi.GetInReplyTo();
	char_set = hi.GetCharset();

	if(!hi.GetDate().IsEmpty()){
		time.SetMailFormatDate(hi.GetDate());
		date.Format("%i", time.GetGmTimeT());
	}

	// dateȂ[̏ꍇ
/*	if(date.IsEmpty()){
		CTime t = CTime::GetCurrentTime();
		date.Format("%i", t.GetTime());
	}*/

	// stat̐ݒ
	if(hi.GetBoundary().IsEmpty() && mail_status == SMRY_STATUS_NEW)
	{
		stat = "N ";
		int nUnreadCount = GetUnreadCount(path);
		nUnreadCount++;
		SaveUnreadCount(path, nUnreadCount, -1);
		RedrawUnreadCount();
	}
	else if(!hi.GetBoundary().IsEmpty() && mail_status == SMRY_STATUS_NONE)
		stat = " M";
	else if(hi.GetBoundary().IsEmpty() && mail_status == SMRY_STATUS_NONE)
		stat = "  ";
	else
		stat = "NM";

	// list̐ݒ
	tmp.Format("%s\\list", path);
	FILE *file = fopen(tmp, "ab");
	if(what_kind_box == SMRY_COLUMN_TO){
		fprintf(file, "%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\r\n",
			size, subject, to, date, seq, stat, message_id, in_reply_to, char_set);
	}else{
		fprintf(file, "%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\r\n",
			size, subject, from, date, seq, stat, message_id, in_reply_to, char_set);
	}
	fclose(file);

	// ۑ悪ݕ\ĂtH_Ȃȉs
	if(g_string_compare_no_case(m_path, g_get_complete_path(path))){
		SLISTSTACK* data = new SLISTSTACK;

		data->m_str1 = size;
		data->m_str2 = subject;
		// ۑɂăT}[ɕ\񂪈Ⴄ
		if(what_kind_box == SMRY_COLUMN_TO)
			data->m_str3 = to;
		else
			data->m_str3 = from;
		data->m_str4 = date;
		data->m_str5 = seq;
		data->m_str6 = stat;
		data->m_str7 = message_id;
		data->m_str8 = in_reply_to;
		data->m_str9 = char_set;

		AddList(data);
		if(m_index != -1){
			m_index++;
		}
		// ǃ[̐m_unread++
		if(stat.Find("N") != -1){
			CString unread;
			unread.Format(" %d  [ %d", ++m_unread, m_stack_num);
			mf->SetStatusBarText(2, unread);
		}
	}

	SetSortRequired(path, true);

	return TRUE;
}

BOOL CSummaryView::SaveMail(LPCTSTR path, CStringArray &mail, int mail_status, int what_kind_box, CString &ret_path)
{
	if(!strlen(path)){
		return FALSE;
	}

	CString header;
	CString subject;
	CString to;
	CString from;
	CString date;
	CString seq;
	CString size;
	CString stat;
	CString message_id;
	CString in_reply_to;
	CString char_set;
	CString tmp;
	CTimeEx time;

	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame *)app->m_pMainWnd;

	// seeking for minimum num. this is used as name of file when mail is saved. MH?
	seq.Format("%d", g_get_min_num(path));

	// save mail path for later reference.
	ret_path.Format("%s\\%s", path, seq);

	// saving mail in MH format ? is this MH format or not, I don't know precisely.
	g_cstringarray2file(ret_path, mail);

	// getting size of mail (this must be done after saving mail)
	size.Format("%d", g_get_file_size(ret_path));

	// decoding mail and getting neccesary information.
	CHeaderInfo hi;
	hi.DoIt(mail);
	subject = hi.GetSubject();
	if(subject.GetLength() > LISTCTRL_BUF_LENGTH){
		subject = subject.Left(LISTCTRL_BUF_LENGTH);
	}
	to = hi.GetTo();
	if(to.GetLength() > LISTCTRL_BUF_LENGTH){
		to = to.Left(LISTCTRL_BUF_LENGTH);
	}
	from = hi.GetFrom();
	message_id = hi.GetMsgID();
	in_reply_to = hi.GetInReplyTo();
	char_set = hi.GetCharset();
	if(!hi.GetDate().IsEmpty()){
		tmp = hi.GetDate();
		time.SetMailFormatDate(tmp);
		tmp.ReleaseBuffer();
		date.Format("%i", time.GetGmTimeT());
	}

	// if mail don't have any information about DATE, below is done.
/*	if(date.IsEmpty()){
		CTime t = CTime::GetCurrentTime();
		date.Format("%i", t.GetTime());
	}*/

	// set current status to stat.
	if(hi.GetBoundary().IsEmpty() && mail_status == SMRY_STATUS_NEW)
	{
		stat = "N ";
		int nUnreadCount = GetUnreadCount(path);
		nUnreadCount++;
		SaveUnreadCount(path, nUnreadCount, -1);
		RedrawUnreadCount();
	}
	else if(!hi.GetBoundary().IsEmpty() && mail_status == SMRY_STATUS_NONE)
		stat = " M";
	else if(hi.GetBoundary().IsEmpty() && mail_status == SMRY_STATUS_NONE)
		stat = "  ";
	else
		stat = "NM";

	// setting content of cummaryview into list.
	tmp.Format("%s\\list", path);
	FILE *file = fopen(tmp, "ab");
	if(what_kind_box == SMRY_COLUMN_TO){
		fprintf(file, "%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\r\n",
			size, subject, to, date, seq, stat, message_id, in_reply_to, char_set);
	}else{
		fprintf(file, "%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\r\n",
			size, subject, from, date, seq, stat, message_id, in_reply_to, char_set);
	}
	fclose(file);

	// if saving to current displayed folder, need to increment m_index. 
	// m_index is variable of current selected item number.
	if(g_string_compare_no_case(m_path, g_get_complete_path(path))){
		SLISTSTACK* data = new SLISTSTACK;
		data->m_str1 = size;
		data->m_str2 = subject;
		// content of summaryview is changing up to which folder is selected in folderview.
		// if outbox is selected, summaryview display [To] address instead of [From].
		// if other box but outbox is selected, viceversa.
		if(what_kind_box == SMRY_COLUMN_TO)
			data->m_str3 = to;
		else
			data->m_str3 = from;
		data->m_str4 = date;
		data->m_str5 = seq;
		data->m_str6 = stat;
		data->m_str7 = message_id;
		data->m_str8 = in_reply_to;
		data->m_str9 = char_set;

		AddList(data);
		if(m_index != -1){
			m_index++;
		}

		// number of unreaded mail is incremented
		if(stat.Find("N") != -1){
			CString unread;
			unread.Format(" %d  [ %d", ++m_unread, m_stack_num);
			mf->SetStatusBarText(2, unread);
		}
	}

	SetSortRequired(path, true);

	return TRUE;
}

BOOL CSummaryView::PreTranslateMessage(MSG* pMsg)
{
	return CListView::PreTranslateMessage(pMsg);
}

// quick sort, is not completed. this cannot work very fast.
void CSummaryView::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if(m_stack_num == 0) return;

	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	// get current order status from folder.ini
	int order = 0;
	int num = GetPrivateProfileInt("list", "order", 0, m_path+"\\folder.ini");

	// change colum mark depending on message order
	if(num/10 == pNMListView->iSubItem){
		switch(num%10){
		case 0:
			num = pNMListView->iSubItem*10+1;
			order = 1;
			break;
		case 1:
			num = pNMListView->iSubItem*10+2;
			order = 2;
			break;
		case 2:
			num = pNMListView->iSubItem*10;
			order = 0;
			break;
		}
	}else{
		num = pNMListView->iSubItem*10+1;
		order = 1;
	}

	// save current order status to folder.ini
	CString buf;
	buf.Format("%d", num);
	WritePrivateProfileString("list", "order", buf, m_path+"\\folder.ini");

	Sort(pNMListView->iSubItem, order);

	*pResult = 0;
}

// below is implementation of quick sort, fuckin dirty code, need to be modified later.
// quicksort related thing must be implemented into sliststacklist class, so refactoring need to be done.
int CSummaryView::QuickSortPartition(int start, int end, int item_num, int order)
{
	int i, j, k;
	long c;
	CString pivot;
	CString buf1;
	CString buf2;

	i = start;
	j = end;
	k = (end+start)/2;
	this->QuickSortSwapStack(k, end);

	if(order != 0){
		switch(item_num){
		case 0:
			pivot = m_array_list.GetAt(end)->m_str6+m_array_list.GetAt(end)->m_str4;
			if(order == 1){
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str6+m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) < 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str6+m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) > 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}else if(order == 2){
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str6+m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) > 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str6+m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) < 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}
			break;
		case 1:
			c = atol(m_array_list.GetAt(end)->m_str1);
			if(order == 1){
				for(;;){
					while(i<j){
						if(c < atol(m_array_list.GetAt(i)->m_str1))
							break;
						i++;
					}
					while(i<j){
						if(c > atol(m_array_list.GetAt(j)->m_str1))
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}else if(order == 2){
				for(;;){
					while(i<j){
						if(c > atol(m_array_list.GetAt(i)->m_str1))
							break;
						i++;
					}
					while(i<j){
						if(c < atol(m_array_list.GetAt(j)->m_str1))
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}
			break;
		case 2:
			pivot = m_array_list.GetAt(end)->m_str2+m_array_list.GetAt(end)->m_str4;
			if(order == 1){
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str2+m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) < 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str2+m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) > 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}else if(order == 2){
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str2+m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) > 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str2+m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) < 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}
			break;
		case 3:
				pivot = m_array_list.GetAt(end)->m_str3+m_array_list.GetAt(end)->m_str4;
			if(order == 1){
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str3+m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) < 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str3+m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) > 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}else if(order == 2){
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str3+m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) > 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str3+m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) < 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}
			break;
		case 4:
/*			if(order == 1){
				pivot = m_array_list.GetAt(end)->m_str4;
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) < 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) > 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}else if(order == 2){
				pivot = m_array_list.GetAt(end)->m_str4;
				for(;;){
					while(i<j){
						buf1 = m_array_list.GetAt(i)->m_str4;
						if(_stricmp(buf1, pivot) > 0)
							break;
						i++;
					}
					while(i<j){
						buf2 = m_array_list.GetAt(j)->m_str4;
						if(_stricmp(buf2, pivot) < 0)
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}
			break;*/
			c = atol(m_array_list.GetAt(end)->m_str4);
			if(order == 1){
				for(;;){
					while(i<j){
						if(c < atol(m_array_list.GetAt(i)->m_str4))
							break;
						i++;
					}
					while(i<j){
						if(c > atol(m_array_list.GetAt(j)->m_str4))
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}else if(order == 2){
				for(;;){
					while(i<j){
						if(c > atol(m_array_list.GetAt(i)->m_str4))
							break;
						i++;
					}
					while(i<j){
						if(c < atol(m_array_list.GetAt(j)->m_str4))
							break;
						j--;
					}
					if(i >= j)
						break;
					this->QuickSortSwapStack(i, j);
				}
			}
			break;
		}
	}else if(order == 0){
		c = atol(m_array_list.GetAt(end)->m_str5);
		for(;;){
			while(i<j){
				if(c < atol(m_array_list.GetAt(i)->m_str5))
					break;
				i++;
			}
			while(i<j){
				if(c > atol(m_array_list.GetAt(j)->m_str5))
					break;
				j--;
			}
			if(i >= j)
				break;
			this->QuickSortSwapStack(i, j);
		}
	}

	this->QuickSortSwapStack(i, end);
	return i;
}

// swap all member of SLISTSTACK one another.
void CSummaryView::QuickSortSwapStack(int i, int j)
{
	SLISTSTACK* pTemp = m_array_list[i];
	m_array_list[i] = m_array_list[j];
	m_array_list[j] = pTemp;
}

// entry function of quick sort.
void CSummaryView::QuickSort(int start, int end, int item_num, int order)
{
	if(start >= end)
		return;

	int p = this->QuickSortPartition(start, end, item_num, order);
	this->QuickSort(start, p-1, item_num, order);
	this->QuickSort(p+1, end, item_num, order);

}

// marking message order on header control of summaryview.
void CSummaryView::SetColumnOrderStatus(int status)
{
	int column = status/10;
	int order = status%10;
	LV_COLUMN clm;
	CString buf;

	clm.mask = LVCF_TEXT;
	clm.cchTextMax = BUF_LENGTH;

	// clear all marking
	for(int i=0; i<5; i++){
		clm.pszText = buf.GetBuffer(BUF_LENGTH);
		this->GetListCtrl().GetColumn(i, &clm);
		buf.ReleaseBuffer();
		buf.Replace(" ", ""); buf.Replace(" ", "");
		clm.pszText = buf.GetBuffer(0);
		this->GetListCtrl().SetColumn(i, &clm);
		buf.ReleaseBuffer();
	}

	// set column order on header control.
	clm.pszText = buf.GetBuffer(BUF_LENGTH);
	this->GetListCtrl().GetColumn(column, &clm);
	buf.ReleaseBuffer();

	switch(order){
	case 1:
		buf+=" ";
		break;
	case 2:
		buf+=" ";
		break;
	}

	clm.pszText = buf.GetBuffer(0);
	this->GetListCtrl().SetColumn(column, &clm);

	buf.ReleaseBuffer();
}

void CSummaryView::ReBuildSummary(CString path, int mode)
{
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CFileFind ff;
	BOOL b;
	CHeaderInfo hi;
	CStringArray header;
	CTimeEx time;

	CString size;
	CString subject;
	CString to;
	CString from;
	CString message_id;
	CString in_reply_to;
	CString char_set;
	CString date;
	CString stat;

	m_array_list.RemoveAll();
	m_stack_num = 0;
	m_status_changed = TRUE;

	b = ff.FindFile(path+"\\*.*");
	while(b){
		header.RemoveAll();
		b = ff.FindNextFile();
		if(ff.IsDots())
			continue;
		if(ff.IsDirectory())
			continue;
		if(ff.GetFileName().SpanExcluding("0123456789").IsEmpty()){
			g_get_header(path+"\\"+ff.GetFileName(), header);
			g_cstringarray2file("debug.txt", header);
			hi.DoIt(header);

			size.Format("%d", g_get_file_size(path + "\\" + ff.GetFileName()));

			subject.Empty();
			subject = hi.GetSubject();
//			subject.Remove('\r');
//			subject.Remove('\n');
			subject.TrimRight("\r\n");

			to.Empty();
			to = hi.GetTo();
//			to.Remove('\r');
//			to.Remove('\n');
			to.TrimRight("\r\n");

			from.Empty();
			from = hi.GetFrom();
//			from.Remove('\r');
//			from.Remove('\n');
			from.TrimRight("\r\n");

			message_id.Empty();
			message_id = hi.GetMsgID();
//			message_id.Remove('\r');
//			message_id.Remove('\n');
			message_id.TrimRight("\r\n");

			in_reply_to.Empty();
			in_reply_to = hi.GetInReplyTo();
//			in_reply_to.Remove('\r');
//			in_reply_to.Remove('\n');
			in_reply_to.TrimRight("\r\n");

			char_set.Empty();
			char_set = hi.GetCharset();
//			char_set.Remove('\r');
//			char_set.Remove('\n');
			char_set.TrimRight("\r\n");

			date.Empty();
//			CString date = g_transform_date(hi.GetDate(), "+0000");
			if(!hi.GetDate().IsEmpty()){
				time.SetMailFormatDate(hi.GetDate());
				date.Format("%i", time.GetGmTimeT());
			}

			stat.Empty();
			// stat̐ݒ
			if(hi.GetBoundary().IsEmpty())
				stat = "N ";
			else
				stat = "NM";

			SLISTSTACK* data = new SLISTSTACK;
			data->m_str1 = size;
			if(subject.GetLength() > LISTCTRL_BUF_LENGTH){
				data->m_str2 = subject.Left(LISTCTRL_BUF_LENGTH);
			}else{
				data->m_str2 = subject;
			}
			data->m_str2 = subject;
			// ۑɂăT}[ɕ\񂪈Ⴄ
			if(mode == SMRY_COLUMN_TO){
				if(to.GetLength() > LISTCTRL_BUF_LENGTH){
					data->m_str3 = to.Left(LISTCTRL_BUF_LENGTH);
				}else{
					data->m_str3 = to;
				}
			}else{
				data->m_str3 = from;
			}
			data->m_str4 = date;
			data->m_str5 = ff.GetFileName();
			data->m_str6 = stat;
			data->m_str7 = message_id;
			data->m_str8 = in_reply_to;
			data->m_str9 = char_set;
			m_array_list.Add(data);
			m_stack_num++;
		}
	}

	// save current message order status to folder.ini
	CString buf;
	buf.Format("%d", 0);
	WritePrivateProfileString("list", "order", buf, m_path+"\\folder.ini");
	Sort(0, 0);

	this->SetItem(path);
	RedrawUnreadCount();

	// invaidate some button in toolbar
	mf->UpdateButton2(FALSE);
}

void CSummaryView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CFolderView *fv = (CFolderView*)mf->m_pTreeV;
	fv->SendMessage(WM_CANCELMODE);
	CListView::OnLButtonUp(nFlags, point);
}

void CSummaryView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	const MSG* msg = GetCurrentMessage();
	CPoint pt1 = msg->pt;
	CPoint pt2 = msg->pt;
	ScreenToClient(&pt1);

	CMenu menu;
	menu.LoadMenu(IDR_SUMMARYVIEW_POPUP);

	CUIntArray ia;
	this->GetSelectedMail(ia);
	if(ia.GetSize() > 1){
		// 폜𖳌ɂ
		menu.EnableMenuItem(ID_SUMMARYVIEW_HEADER_INFO, MF_GRAYED);
		menu.EnableMenuItem(ID_SUMMARYVIEW_RAWMAIL_INFO, MF_GRAYED);
	}else{
		// Lɂ
		menu.EnableMenuItem(ID_SUMMARYVIEW_HEADER_INFO, MF_ENABLED);
		menu.EnableMenuItem(ID_SUMMARYVIEW_RAWMAIL_INFO, MF_ENABLED);
	}

	CPochyApp* pPochyApp = (CPochyApp*)::AfxGetApp();
	if (pPochyApp != NULL)
	{
		pPochyApp->m_pluginManager.OnInitMenu(menu.GetSubMenu(0)->GetSafeHmenu(), POCHY_MENU_SUMMARY_VIEW);
	}

	CMenu *popup = menu.GetSubMenu(0);
	popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON |TPM_LEFTBUTTON, (int)pt2.x, (int)pt2.y, this);
	*pResult = 0;
}

void CSummaryView::OnPopupDel() 
{
	if(this->m_index == -1){
		return;
	}
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CFolderView *fv = (CFolderView *)mf->m_pTreeV;
	CStringArray cstra;
	CUIntArray ia;
	CString message;

	CString current_account = mf->m_pAcntV->GetCurrentAccountName();
	this->GetSelectedMail(ia);
	if(fv->GetSelectedItemKind() != FV_TRASH){
		if(ia.GetSize() == 1){
			message = this->m_array_list[this->m_stack_num-this->m_index-1]->m_str2+"\r\n\r\ntrashɈڂĂ悢łH";
		}else if(ia.GetSize() > 1){
			message = "\r\n\r\ntrashɈڂĂ悢łH";
		}
		if(IDYES != AfxMessageBox(message, MB_YESNO)){
			return;
		}
		this->MoveMail(ia, app->m_app_path+"\\"+current_account+"\\trash", SMRY_COLUMN_FROM);
	}else{
		if(ia.GetSize() == 1){
			message = this->m_array_list[this->m_stack_num-this->m_index-1]->m_str2+"\r\n\r\n폜Ă悢łH";
		}else if(ia.GetSize() > 1){
			message = "\r\n\r\n폜Ă悢łH";
		}
		if(IDYES != AfxMessageBox(message, MB_YESNO)){
			return;
		}		
		this->DeleteMail(ia);
	}
	// imvalidate some button in toolbar
	mf->UpdateButton2(FALSE);
}

void CSummaryView::OnPopupHeaderInfo() 
{
	if(this->m_index == -1){
		return;
	}
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame *)app->m_pMainWnd;
	CTextView *tv = (CTextView *)mf->m_pTextV;
	CString msg_id = g_ma(tv->GetCurrentMsgID());
	msg_id.Remove('.');
	msg_id.Remove('/');
	msg_id.Remove(':');
	msg_id.Remove('*');
	msg_id.Remove('?');
	msg_id.Remove('\"');
	msg_id.Remove('|');
	CString file_name = msg_id+"_header.txt";

	if(!g_is_there(app->m_app_path+"\\temp")) // if attached folder does not exist, create.
		_mkdir(app->m_app_path+"\\temp");
	CString file_path = app->m_app_path+"\\temp\\"+file_name;

	FILE* file = fopen(file_path, "wb");
	fwrite(tv->GetCurrentRawHeader(),
		sizeof(char),
		tv->GetCurrentRawHeader().GetLength(),
		file);
	fclose(file);

	CString editor_path = app->GetProfileString("Editor", "Path", "notepad");
	if(editor_path.IsEmpty())
		editor_path = "notepad";
	file_path = "\""+file_path+"\"";
	// open file with editor designated in setting.ini.
	ShellExecute(NULL,NULL, editor_path, file_path, NULL, SW_NORMAL);
}

void CSummaryView::OnPopupRawmailInfo() 
{
	if(this->m_index == -1){
		return;
	}
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame *)app->m_pMainWnd;
	CTextView *tv = (CTextView *)mf->m_pTextV;
	CString editor_path = app->GetProfileString("Editor", "Path", "notepad");
	if(editor_path.IsEmpty())
		editor_path = "notepad";	
	// open file with editor designated in setting.ini.
	ShellExecute(NULL,NULL, editor_path,
		"\""+tv->GetCurrentPath()+"\"",
		NULL,
		SW_NORMAL);	
}

void CSummaryView::OnPopupRebuild() 
{
	CWaitCursor wait_cursor; // turn cursor into sandglass
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame *)app->m_pMainWnd;
	CFolderView *fv = (CFolderView *)mf->m_pTreeV;
	
	int mode = SMRY_COLUMN_FROM;
	switch(fv->GetSelectedItemKind()){
	case FV_INBOX:
	case FV_TRASH:
	case FV_TOP:
	case FV_OTHER:
		mode = SMRY_COLUMN_FROM;
		break;
	case FV_OUTBOX:
	case FV_DRAFT:
		mode = SMRY_COLUMN_TO;
		break;
	default:
		break;
	}

	this->ReBuildSummary(this->m_path, mode);
	mf->UpdateButton2(FALSE);
}

void CSummaryView::ClearAllMail(LPCTSTR path)
{
	CFileFind ff;
	CWaitCursor wait_cursor; // turn cursor into sandglass
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame *)app->m_pMainWnd;
	CHeaderView *hv = (CHeaderView *)mf->m_pHeadV;
	CTextView *tv = (CTextView *)mf->m_pTextV;
	CString tmp;

	tmp.Format("%s\\*.*", path);
	BOOL b = ff.FindFile(tmp);
	if(b){
		while(b){
			b = ff.FindNextFile();
			if(!ff.IsDirectory() && !ff.IsDots()){
				tmp.Format("%s\\%s", path, ff.GetFileName());
				DeleteFile(tmp);
			}
		}
		if(path == this->m_path){
			// refresh summaryview
			this->m_array_list.RemoveAll();
			this->SetItem(path);
			hv->Clear();
			tv->Clear();
		}
	}
}

void CSummaryView::MoveMail(CUIntArray &index_array, CString to, int what_kind_box)
{
	if(to.IsEmpty() || index_array.GetSize() < 1){
		return;
	}
	
	CWaitCursor wait_cursor; // turn cursor into sandglass

	CStringArray cstra;
	CString dummy;

	int i;
	int max = index_array.GetSize();
	for(i=0; i<max; i++){
		cstra.RemoveAll();
		g_file2cstringarray(this->m_path+"\\"+this->m_array_list.GetAt(this->m_stack_num-index_array.GetAt(i)-1)->m_str5, cstra);
		this->SaveMail(to, cstra, SMRY_STATUS_NONE, what_kind_box, dummy);
	}
	this->DeleteMail(index_array);
	SortWithRequiredCheck();
}

void CSummaryView::Clear()
{
	// first of all, save current summary list into list file
	WriteList();

	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)this->GetParentFrame();
	CListCtrl& lc = GetListCtrl();

	// delete all item;	
	SelectItem(-1);
	this->m_array_list.RemoveAll();
	this->m_stack_num = 0;
	this->m_path.Empty();
	this->m_unread = 0;
	this->m_index = -1;
	lc.SetItemCountEx(m_stack_num, LVSICF_NOSCROLL);

	// save width of listview column into ini file
	CString num;
	for(int i = 0; i < 5; i++){
		num.Format("%d", i);
		app->WriteProfileInt("SummaryViewColumn", num, lc.GetColumnWidth(i));
	}

	// T}[r[̃J̏Ԃ ini t@C֕ۑ
	WriteIniColumnOrder();

	// change column text for default
	this->UpdateColumn(SMRY_COLUMN_FROM);

	// renew infomation of mail in statusbar
	mf->SetStatusBarText(2, " 0  [ 0");
	SaveUnreadCount(m_path, 0, 0);
	RedrawUnreadCount();
}

void CSummaryView::GetSelectedMail(CUIntArray &index_array)
{
	POSITION pos = this->GetListCtrl().GetFirstSelectedItemPosition();
	index_array.RemoveAll();
	while(pos){
		index_array.Add(this->GetListCtrl().GetNextSelectedItem(pos));
	}
}

void CSummaryView::OnKillFocus(CWnd* pNewWnd)
{
	CListView::OnKillFocus(pNewWnd);

	// ACeĕ`悵ĕύX\
	if (pNewWnd != NULL && pNewWnd->GetParent() == this) return;
	if ((GetStyle() & LVS_TYPEMASK) == LVS_REPORT) RepaintSelectedItems();
}

void CSummaryView::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	// ACe̍Zbg
	int iHeight = 0;
	if (iHeight < m_ReadFontHeight) iHeight = m_ReadFontHeight;
	if (iHeight < m_UnreadFontHeight) iHeight = m_UnreadFontHeight;
	if (m_bIconUsed && iHeight < m_IconImageHeight) iHeight = m_IconImageHeight;
	lpMeasureItemStruct->itemHeight = iHeight;
}

void CSummaryView::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	static _TCHAR szBuff[LISTCTRL_BUF_LENGTH];	// Œobt@TCYɒ
	BOOL bFocus, bSelected;
	COLORREF colText, colBk, colIconBk;
	CFont* pFontSave;
	COLORREF colTextSave, colBkSave;
	LPCTSTR pszText;

	CListCtrl& cListCtrl = GetListCtrl();
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	int nItem = lpDrawItemStruct->itemID;

	bool bIconUsed = m_bIconUsed;
	if (m_IconImage.m_hImageList == NULL) bIconUsed = false;

	// ACef[^擾
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
	lvItem.iItem = nItem;
	lvItem.iSubItem = 0;
	lvItem.pszText = szBuff;
	lvItem.cchTextMax = sizeof(szBuff);
	lvItem.stateMask = 0xFFFF;
	cListCtrl.GetItem(&lvItem);

	// [Xe[^X擾
	bool bMailUnread = (szBuff[0] == 'N');		// 
	bool bMailDelete = (szBuff[0] == 'D');		// 폜
	bool bMailAttach = (szBuff[1] == 'M');		// Yt

	// IԂ̎擾
	bFocus = (GetFocus() == this);
	bSelected = (bFocus || (GetStyle() & LVS_SHOWSELALWAYS)) && lvItem.state & LVIS_SELECTED;
	bSelected = bSelected || (lvItem.state & LVIS_DROPHILITED);

	CRect rcLabel, rcAllLabels;
	cListCtrl.GetItemRect(nItem, rcLabel, LVIR_LABEL);
	cListCtrl.GetItemRect(nItem, rcAllLabels, LVIR_BOUNDS);

	CRect rcMemAllLabels = rcAllLabels;
	rcMemAllLabels.OffsetRect(-rcAllLabels.left, -rcAllLabels.top);
	CRect rcMemLabel = rcLabel;
	rcMemLabel.OffsetRect(-rcAllLabels.left, -rcAllLabels.top);

	CMemoryDC memDCBase;
	memDCBase.Create(pDC->GetSafeHdc(), rcAllLabels.Width(), rcAllLabels.Height());
	CDC memDC;
	memDC.Attach(memDCBase.GetDC());

	// tHgƃJ[ݒ
	if (!bMailUnread){
		pFontSave = memDC.SelectObject(&m_cReadFont);
		colText = ((bSelected) ? m_colSelectText : m_colReadText);
		colBk = ((bSelected) ? m_colSelectBk : m_colReadBk);
		colIconBk = m_colReadBk;
	} else {
		pFontSave = memDC.SelectObject(&m_cUnreadFont);
		colText = ((bSelected) ? m_colSelectText : m_colUnreadText);
		colBk = ((bSelected) ? m_colSelectBk : m_colUnreadBk);
		colIconBk = m_colUnreadBk;
	}
	if ((lvItem.state & LVIS_FOCUSED) && bFocus){
		colTextSave = memDC.SetTextColor(colText);
	}else if((lvItem.state & LVIS_FOCUSED)){
		colTextSave = memDC.SetTextColor(GetSysColor(COLOR_MENUTEXT));
	}
	else
	{
		colTextSave = memDC.SetTextColor(colText);
	}
	colBkSave = memDC.SetBkColor(colBk);
	int nBkModeSave = memDC.SetBkMode(TRANSPARENT);

	// s̔wiNA
	if (bSelected || !HasBkBitmap())
	{
		memDC.FillRect(rcMemAllLabels, &CBrush(colBk));
	}
	else
	{
		::BitBlt(memDC.GetSafeHdc(), 0, 0, rcAllLabels.Width(), rcAllLabels.Height(),
			m_bkMemDC.GetDC(), rcAllLabels.left, rcAllLabels.top, SRCCOPY);
	}

	// tH[JX``
	// need to cope with GetThemeColor
	if ((lvItem.state & LVIS_FOCUSED) && bFocus){
		memDC.DrawFocusRect(rcMemAllLabels);
	}else if((lvItem.state & LVIS_FOCUSED)){
		memDC.FillRect(rcMemAllLabels, &CBrush(GetSysColor(COLOR_BTNFACE)));
	}

	// ACR`
	if (bIconUsed){
		
		CPoint cPos(rcMemLabel.left, rcMemLabel.top);
		
		// YtACR
		if (cPos.x < rcMemLabel.right){
			if (bMailAttach) m_IconImage.Draw(&memDC, SUMMARYVIEW_ICON_ATTACH, cPos, ILD_TRANSPARENT);
		}
		cPos.x += m_IconImageWidth;

		// ǁIǁ폜ACR
		if (cPos.x < rcMemLabel.right){
			int iIcon = SUMMARYVIEW_ICON_READ;
			if (bMailUnread) iIcon = SUMMARYVIEW_ICON_UNREAD;
			if (bMailDelete) iIcon = SUMMARYVIEW_ICON_DELETE;
			if (bSelected) iIcon = SUMMARYVIEW_ICON_SELECT;
			m_IconImage.Draw(&memDC, iIcon, cPos, ILD_TRANSPARENT);
		}
	}

	// ŏ̃J̕`(ACRgp)
	if (!bIconUsed){
		int iOffsetFirst = 2;
		pszText = MakeShortString(&memDC, szBuff, (rcMemLabel.right-rcMemLabel.left), (iOffsetFirst*2));
		rcMemLabel.left += iOffsetFirst;
		rcMemLabel.right -= iOffsetFirst;
		memDC.DrawText(
			pszText, -1, rcMemLabel,
			(DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER)
		);
	}

	// QԖڈȍ~̃J̕`
	CRect rcColumn, rcMemColumn;
	LV_COLUMN lvColumn;
	int iOffsetOther = 6;
	lvColumn.mask = LVCF_FMT;
	cListCtrl.GetItemRect(nItem, rcColumn, LVIR_LABEL);
	for(int nColumn = 1; cListCtrl.GetColumn(nColumn, &lvColumn); nColumn++){
		
		cListCtrl.GetSubItemRect(nItem, nColumn, LVIR_BOUNDS, rcColumn);
		rcMemColumn = rcColumn;
		rcMemColumn.OffsetRect(-rcAllLabels.left, -rcAllLabels.top);
		if (cListCtrl.GetItemText(nItem, nColumn, szBuff, sizeof(szBuff)) == 0) continue;

		if (nColumn == 1)
		{
			// TCY̓J}؂萔
			const std::string strBuffer = szBuff;
			if (MakeCommaNumber(strBuffer.c_str(), szBuff, 512) == 0)
			{
				_tcsncpy(szBuff, strBuffer.c_str(), strBuffer.length());
			}
		}

		UINT nJustify = DT_LEFT;
		pszText = MakeShortString(&memDC, szBuff, (rcMemColumn.right-rcMemColumn.left), (iOffsetOther*2));
		if(pszText == szBuff){
			switch(lvColumn.fmt & LVCFMT_JUSTIFYMASK){
			case LVCFMT_RIGHT:
				nJustify = DT_RIGHT;
				break;
			case LVCFMT_CENTER:
				nJustify = DT_CENTER;
				break;
			default:
				break;
			}
		}
		
		rcLabel = rcMemColumn;
		rcLabel.left += iOffsetOther;
		rcLabel.right -= iOffsetOther;
		memDC.DrawText(
			pszText, -1, rcLabel,
			(nJustify | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER)
		);		
	}

	// foCXReLXg̑߂
	memDC.SetBkColor(colBkSave);
	memDC.SetTextColor(colTextSave);
	memDC.SelectObject(pFontSave);
	memDC.SetBkMode(nBkModeSave);

	pDC->BitBlt(rcAllLabels.left, rcAllLabels.top, rcAllLabels.Width(), rcAllLabels.Height(),
		&memDC, 0, 0, SRCCOPY);
}

LPCTSTR CSummaryView::MakeShortString(CDC* pDC, LPCTSTR lpszLong, int nColumnLen, int nOffset)
{
	static _TCHAR szShort[LISTCTRL_BUF_LENGTH+1];		// Œobt@TCYɒ
	static const _TCHAR szThreeDots[] = _T("...");

	int nStringLen = lstrlen(lpszLong);
	if(nStringLen == 0 || (pDC->GetTextExtent(lpszLong, nStringLen).cx + nOffset) <= nColumnLen){
		return(lpszLong);
	}

	int i, j;
	int nAddLen = pDC->GetTextExtent(szThreeDots, sizeof(szThreeDots)).cx;

	i = j = 0;
	while(lpszLong[i] != 0){
		j = i;
		
		if (_istlead(lpszLong[i]) != 0){
			szShort[i+0] = lpszLong[i+0];
			szShort[i+1] = lpszLong[i+1];
			i += 2;
		} else {
			szShort[i+0] = lpszLong[i+0];
			i++;
		}
		szShort[i] = 0;
		
		if((pDC->GetTextExtent(szShort, i).cx + nOffset + nAddLen) > nColumnLen){
			szShort[j] = 0;
			break;
		}
		
	}
	lstrcat(szShort, szThreeDots);

	return(szShort);
}

void CSummaryView::RepaintSelectedItems(void)
{
	CRect rcItem, rcLabel;
	CListCtrl& cListCtrl = GetListCtrl();

	int nItem = cListCtrl.GetNextItem(-1, LVNI_FOCUSED);

	if(nItem != -1){
		cListCtrl.GetItemRect(nItem, rcItem, LVIR_BOUNDS);
		cListCtrl.GetItemRect(nItem, rcLabel, LVIR_LABEL);
		rcItem.left = rcLabel.left;
		InvalidateRect(rcItem, FALSE);
		this->UpdateWindow();
	}

	if(!(GetStyle() & LVS_SHOWSELALWAYS)){
		for(nItem = cListCtrl.GetNextItem(-1, LVNI_SELECTED);
			nItem != -1; nItem = cListCtrl.GetNextItem(nItem, LVNI_SELECTED)){
			cListCtrl.GetItemRect(nItem, rcItem, LVIR_BOUNDS);
			cListCtrl.GetItemRect(nItem, rcLabel, LVIR_LABEL);
			rcItem.left = rcLabel.left;
			InvalidateRect(rcItem, FALSE);
			this->UpdateWindow();
		}
	}

	UpdateWindow();
}

void CSummaryView::ReadIconImage(void)
{
	CString strFilePath;
	HBITMAP hBitmap;

	// XLt@C̓ǂݍ
//	strFilePath = ((CPochyApp*)::AfxGetApp())->m_app_path + SUMMARYVIEW_FILENAME;
	// skin.ini
	CPochyApp *pApp =(CPochyApp*)::AfxGetApp();
	if(pApp->m_skin.getSummarryViewIcons() == ""){
		strFilePath = ((CPochyApp*)::AfxGetApp())->m_app_path + SUMMARYVIEW_FILENAME;
	}else{
		strFilePath = pApp->m_skin.getSkinIniPath() + "\\" + pApp->m_skin.getSummarryViewIcons();
	}
	hBitmap = (HBITMAP)::LoadImage(NULL, strFilePath, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	// C[WXgɐݒ
	if (hBitmap != NULL){
		CBitmap* pBitmap = CBitmap::FromHandle(hBitmap);
		if (pBitmap != NULL){
			BITMAP bitmap;
			if (pBitmap->GetBitmap(&bitmap) != 0){
				int iWidth = (bitmap.bmWidth / 5);
				int iHeight = bitmap.bmHeight;
				if (m_IconImage.Create(iWidth, iHeight, ILC_COLOR8|ILC_MASK, 0, 5)){
					m_IconImage.Add(pBitmap, SUMMARYVIEW_TRANSPARENT_COLOR);
					m_IconImageHeight = iHeight;
					m_IconImageWidth = iHeight;
				}
			}
		}
		::DeleteObject(hBitmap);
		return;
	}

	// \[X̓ǂݍ
	if (m_IconImage.Create(SUMMARYVIEW_RESICON_W, SUMMARYVIEW_RESICON_H, ILC_COLOR8|ILC_MASK, 0, 5)){
		CBitmap bmp;
		if(bmp.LoadBitmap(IDB_SUMMARYVIEW)){
			m_IconImage.Add(&bmp, SUMMARYVIEW_TRANSPARENT_COLOR);
			m_IconImageHeight = SUMMARYVIEW_RESICON_H;
			m_IconImageWidth = SUMMARYVIEW_RESICON_W;
		}
		bmp.DeleteObject();
	}
}

COLORREF CSummaryView::ReadIniColor(LPCTSTR lpszKeyName, COLORREF colDefault)
{
	int r, g, b;
	_TCHAR szKeyName[64];

	CPochyApp *app = (CPochyApp *)AfxGetApp();

	lstrcpy(szKeyName, lpszKeyName);
	lstrcat(szKeyName, _T("R"));
	r = app->GetProfileInt(_T("SummaryViewColor"), szKeyName, GetRValue(colDefault));

	lstrcpy(szKeyName, lpszKeyName);
	lstrcat(szKeyName, _T("G"));
	g = app->GetProfileInt(_T("SummaryViewColor"), szKeyName, GetGValue(colDefault));

	lstrcpy(szKeyName, lpszKeyName);
	lstrcat(szKeyName, _T("B"));
	b = app->GetProfileInt(_T("SummaryViewColor"), szKeyName, GetBValue(colDefault));

	return RGB(r, g, b);
}

bool CSummaryView::ReadIniFont(LPCTSTR lpszKeyName, LOGFONT* lpLogFont)
{
	LPBYTE pData;
	UINT nSize;

	CPochyApp *app = (CPochyApp *)AfxGetApp();
	if(app->GetProfileBinary(_T("SummaryViewFont"), lpszKeyName, &pData, &nSize)){
		ASSERT(nSize == sizeof(LOGFONT));
		::CopyMemory(lpLogFont, pData, sizeof(LOGFONT));
		delete [] pData;
		return true;
	}

	return false;
}

void CSummaryView::UpdateSummaryView(void)
{
	CRect rcRect;
	GetWindowRect(&rcRect);

	WINDOWPOS WinPos;
	ZeroMemory(&WinPos, sizeof(WINDOWPOS));
	WinPos.hwnd = GetSafeHwnd();
	WinPos.cx = rcRect.Width();
	WinPos.cy = rcRect.Height();
	WinPos.flags = SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER;

	// WM_MEASUREITEMbZ[W𔭍sׂɍs
	SendMessage(WM_WINDOWPOSCHANGED, 0, (LPARAM)&WinPos);
}

void CSummaryView::SetIconUsed(bool bUsed)
{
	m_bIconUsed = bUsed;
}

void CSummaryView::SetReadFont(const LOGFONT* lpLogFont)
{
	m_ReadFontHeight = abs(lpLogFont->lfHeight);
	m_cReadFont.CreateFontIndirect(lpLogFont);
}

void CSummaryView::SetUnreadFont(const LOGFONT* lpLogFont)
{
	m_UnreadFontHeight = abs(lpLogFont->lfHeight);
	m_cUnreadFont.CreateFontIndirect(lpLogFont);
}

void CSummaryView::SetReadTextColor(COLORREF colColor)
{
	m_colReadText = colColor;
}

void CSummaryView::SetReadBkColor(COLORREF colColor)
{
	m_colReadBk = colColor;
	GetListCtrl().SetBkColor(colColor);
}

void CSummaryView::SetUnreadTextColor(COLORREF colColor)
{
	m_colUnreadText = colColor;
}

void CSummaryView::SetUnreadBkColor(COLORREF colColor)
{
	m_colUnreadBk = colColor;
}

void CSummaryView::SetSelectTextColor(COLORREF colColor)
{
	m_colSelectText = colColor;
}

void CSummaryView::SetSelectBkColor(COLORREF colColor)
{
	m_colSelectBk = colColor;
}

void CSummaryView::ReadIniColumnOrder()
{
	// T}[r[̃J̏Ԃ ini t@Cݒ
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	int nHeaderCount = GetListCtrl().GetHeaderCtrl()->GetItemCount();
	int* piArray = new int[nHeaderCount];
	for (int i = 0; i < nHeaderCount; i++)
	{
		CString buffer;
		buffer.Format(_T("%s%d"), _T("Order"), i);
		piArray[i] = app->GetProfileInt(_T("SummaryViewColumn"), buffer, -1);
	}
	if (piArray[0] >= 0)
	{
		GetListCtrl().SetColumnOrderArray(nHeaderCount, piArray);
	}
	delete[] piArray;
}

void CSummaryView::WriteIniColumnOrder()
{
	// T}[r[̃J̏Ԃ ini t@C֕ۑ
	CPochyApp *app = (CPochyApp *)AfxGetApp();
	int nHeaderCount = GetListCtrl().GetHeaderCtrl()->GetItemCount();
	int* piArray = new int[nHeaderCount];
	if (GetListCtrl().GetColumnOrderArray(piArray) != 0)
	{
		for (int i = 0; i < nHeaderCount; i++)
		{
			CString buffer;
			buffer.Format(_T("%s%d"), _T("Order"), i);
			app->WriteProfileInt(_T("SummaryViewColumn"), buffer, piArray[i]);
		}
	}
	delete[] piArray;
}

// ǐ folder.ini ɕۑ
void CSummaryView::SaveUnreadCount(const CString& strPath, const int nUnread, const int /*nStack*/)
{
	if (strPath != _T(""))
	{
		CString strBuffer;
		strBuffer.Format(_T("%d"), nUnread);
		::WritePrivateProfileString(_T("list"), _T("UnreadCount"), strBuffer, strPath + _T("\\folder.ini"));
	}
}

// ǐ folder.ini 擾
// ꍇ͌vZĒlԂ
int CSummaryView::GetUnreadCount(const CString& strPath)
{
	int nUnread = ::GetPrivateProfileInt(_T("list"), _T("UnreadCount"), -1, strPath + _T("\\folder.ini")); 
	if (nUnread < 0)
	{
		nUnread = CalcUnreadCount(strPath);
	}

	return nUnread;
}

// ǐvZ folder.ini ɕۑĒlԂ
int CSummaryView::CalcUnreadCount(const CString& strPath)
{
	CString tmp;
	CString message;
	CStrTok StrTok;

	CStdioFile ReadFile;
	if(!ReadFile.Open(strPath+"\\list", CFile::modeRead | CFile::typeText)){
		// listȂꍇ͂悤ɂ
		g_file_create(strPath+"\\list");
		if(!ReadFile.Open(strPath+"\\list", CFile::modeRead | CFile::typeText)){
			message.Format("CSummaryView: cannot open %s\\list", strPath);
			AfxMessageBox(message);
			TRACE(message);
			return -1;
		}
	}
	int nStack = 0;
	int nUnread = 0;
	while(ReadFile.ReadString(tmp)){
		StrTok.Tokenize(tmp.GetBuffer(0), "\x02"); // case 1
		StrTok.Tokenize(NULL, "\x02"); // case 2
		StrTok.Tokenize(NULL, "\x02"); // case 3
		StrTok.Tokenize(NULL, "\x02"); // case 4
		StrTok.Tokenize(NULL, "\x02"); // case 5
		CString strUnread = StrTok.Tokenize(NULL, "\x02"); // case 6
		if (strUnread.Find(_T("N")) != -1)
		{
			nUnread++;
		}
		tmp.Empty();
		nStack++;
	}
	ReadFile.Close();

	SaveUnreadCount(strPath, nUnread, nStack);
	return(nUnread);
}

// ǐĕ`悷 (tH_[c[r[ĕ`)
void CSummaryView::RedrawUnreadCount()
{
	CPochyApp* pPochyApp = (CPochyApp*)AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pPochyApp->m_pMainWnd;
	CFolderView* pFolderView = (CFolderView*)pMainFrame->m_pTreeV;
	if (pFolderView->GetShowUnreadCount())
	{
		pFolderView->Invalidate(TRUE);
		pFolderView->UpdateWindow();
	}
}

BOOL CSummaryView::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	CPochyApp* pPochyApp = (CPochyApp*)AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pPochyApp->m_pMainWnd;
	CAccountView* av = (CAccountView*)pMainFrame->m_pAcntV;

	if(av->IsAnyAccountFetching())
		return TRUE;

	switch (LOWORD(wParam))
	{
	case ID_CHECK_DELETE_MARK:
		{
			if(this->m_index != -1){
				this->m_status_changed |= this->MarkDStatus(m_index);
				this->SelectNext();
			}
			return TRUE;
		}
		break;

	case ID_UNCHECK_DELETE_MARK:
		{
			if(this->m_index != -1){
				this->m_status_changed |= UnmarkStatus(m_index);
				this->SelectNext();
			}
			return TRUE;
		}
		break;

	case ID_EXECUTE_DELETE_MARK:
		{
			int i;
			CUIntArray ia;
			CPochyApp *app = (CPochyApp *)AfxGetApp();
			CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
			CFolderView *fv = (CFolderView *)mf->m_pTreeV;
			CString current_account = mf->m_pAcntV->GetCurrentAccountName();
			for(i=this->m_array_list.GetSize()-1; i >= 0; i--){
				if(this->m_array_list.GetAt(i)->m_str6.Find("D") != -1){
					ia.Add(this->m_stack_num-i-1);
				}
			}
			if(fv->GetSelectedItemKind() != FV_TRASH){
				this->MoveMail(ia, app->m_app_path+"\\"+current_account+"\\trash", SMRY_COLUMN_FROM);
			}else{
				this->DeleteMail(ia);
			}
			return TRUE;
		}
		break;

	case ID_SELECT_TOP_MAIL:
		{
			SelectItem(0);
			return TRUE;
		}
		break;

	case ID_SELECT_BOTTOM_MAIL:
		{
			SelectItem(m_stack_num - 1);
			return TRUE;
		}
		break;
	}

	if (pPochyApp != NULL)
	{
		CMainFrame *pMainFrame = (CMainFrame*)pPochyApp->m_pMainWnd;
		if (pMainFrame != NULL)
		{
			pMainFrame->CallPluginCallback(this->GetSafeHwnd(), LOWORD(wParam));
		}
	}

	return CBitmapListView::OnCommand(wParam, lParam);
}

void CSummaryView::OnNextMail()
{
	if (m_stack_num > 0)
	{
		int nNextMail = m_index;
		if (m_index >= 0 && m_index < m_stack_num - 1)
		{
			nNextMail++;
		}
		else
		{
			nNextMail = 0;
		}

		if (m_index != nNextMail)
		{
			SelectItem(nNextMail);
		}
	}
}

void CSummaryView::OnPrevMail()
{
	if (m_stack_num > 0)
	{
		int nPrevMail = m_index;
		if (m_index > 0 && m_index < m_stack_num)
		{
			nPrevMail--;
		}
		else
		{
			nPrevMail = m_stack_num - 1;
		}

		if (m_index != nPrevMail)
		{
			SelectItem(nPrevMail);
		}
	}
}

void CSummaryView::OnNextUnreadMail()
{
	SelectNextUnreadMail();
}

void CSummaryView::SelectItem(const int &nSelect)
{
	if(-1 <= nSelect && nSelect < m_stack_num)
	{
		// ׂĂ̑I
		CListCtrl& listCtrl = GetListCtrl();
		POSITION pos = listCtrl.GetFirstSelectedItemPosition();
		if (pos != NULL)
		{
			while (pos)
			{
				int nItem = listCtrl.GetNextSelectedItem(pos);
				GetListCtrl().SetItemState(nItem, (UINT)~(LVIS_SELECTED | LVIS_FOCUSED), LVIS_SELECTED | LVIS_FOCUSED);
			}
		}

		if (nSelect >= 0)
		{
			// select
			GetListCtrl().SetItemState(nSelect, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
			GetListCtrl().EnsureVisible(nSelect, TRUE);
		}
	}
}

void CSummaryView::SelectNextUnreadMail()
{
	CPochyApp* pApp = (CPochyApp*)::AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;

	if (m_unread <= 0)
	{
		pMainFrame->SelectNextUnreadFolder();
	}

	if (m_unread > 0 && m_stack_num > 0)
	{
		int nIndex = m_index;
		if (m_index < 0 || m_index >= m_stack_num)
		{
			nIndex = 0;
		}

		int i;
		for (i = nIndex; i < m_stack_num; i++)
		{
			CString strFlag = m_array_list.GetAt(m_stack_num - i - 1)->m_str6;
			if (strFlag.Left(1) == _T('N'))
			{
				SelectItem(i);
				return;
			}
		}

		for (i = 0; i < nIndex; i++)
		{
			CString strFlag = m_array_list.GetAt(m_stack_num - i - 1)->m_str6;
			if (strFlag.Left(1) == _T('N'))
			{
				SelectItem(i);
				return;
			}
		}
	}
	else
	{
		::MessageBeep((UINT)-1);
	}
}

void CSummaryView::SetSortRequired(const CString& strPath, bool bSortRequired)
{
	CString strFolderIni = strPath;
	if (strPath == _T(""))
	{
		strFolderIni = m_path;
	}
	strFolderIni += _T("\\folder.ini");

	CString strBuffer = _T("0");
	if (bSortRequired)
	{
		strBuffer = _T("1");
	}

	WritePrivateProfileString(_T("list"), _T("sortRequired"), strBuffer, strFolderIni);
}

bool CSummaryView::IsSortRequired(const CString& strPath)
{
	CString strFolderIni = strPath;
	if (strPath == _T(""))
	{
		strFolderIni = m_path;
	}
	strFolderIni += _T("\\folder.ini");

	return GetPrivateProfileInt(_T("list"), _T("sortRequired"), 0, strFolderIni) == 1;
}

void CSummaryView::Sort(int nColumn, int nOrder)
{
	if(m_stack_num == 0) return;

	CWaitCursor wait_cursor;

	if (nColumn < 0 || nOrder < 0)
	{
		int num = GetPrivateProfileInt("list", "order", 0, m_path+"\\folder.ini");
		nColumn = num / 10;
		nOrder = num % 10;
	}
	// start quicksort
//	int nStart = 0;
/*	if (nColumn == 1)
	{
		nStart = 1;
	}*/
	m_status_changed = TRUE;
	this->QuickSort(/*nStart*/0, m_array_list.GetUpperBound(), nColumn, nOrder);


	CPochyApp* app = (CPochyApp*)AfxGetApp();
	CMainFrame *mf = (CMainFrame*)app->m_pMainWnd;
	CTextView *tv =(CTextView*)mf->m_pTextV;
	CHeaderView *hv = (CHeaderView*)mf->m_pHeadV;
	CListCtrl &lc = GetListCtrl();

	SetColumnOrderStatus(nColumn * 10 + nOrder);

	m_index = -1;
	SelectItem(-1);
	hv->Clear();
	tv->Clear();
	mf->HideMultiPartView(TRUE);
	mf->UpdateButton2(FALSE);
	lc.SetItemCountEx(m_stack_num, LVSICF_NOSCROLL);

	SetSortRequired(m_path, false);
}

void CSummaryView::SortWithRequiredCheck(int nColumn, int nOrder)
{
	if (IsSortRequired())
	{
		Sort(nColumn, nOrder);
	}
}

int CSummaryView::MakeCommaNumber(LPCTSTR lpszSrc, LPTSTR lpNumberStr, int cchNumber)
{
	NUMBERFMT nf;
	nf.Grouping = 3;
	nf.NumDigits = 0;
	nf.LeadingZero = 1;
	nf.lpThousandSep = _T(",");
	nf.lpDecimalSep = _T(".");
	nf.NegativeOrder = 1;

	return ::GetNumberFormat(LOCALE_USER_DEFAULT, 0, lpszSrc, &nf, lpNumberStr, cchNumber);
}

void CSummaryView::SetNoSortHeader(BOOL b)
{
	CHeaderCtrl *hc = (CHeaderCtrl *)this->GetListCtrl().GetDlgItem(0);

	if(b){
		hc->ModifyStyle(HDS_BUTTONS, 0);
	}else{
		hc->ModifyStyle(0, HDS_BUTTONS);
	}
}

BOOL CSummaryView::MakeShortCut(LPCTSTR org_file_path, LPCTSTR dst_folder_path, int mail_status, int what_kind_box)
{
	if(!strlen(dst_folder_path) || !strlen(org_file_path)){
		return FALSE;
	}

//	CString list;
	CString path;
	CString subject;
	CString to;
	CString from;
	CString date;
	CString seq;
	CString size;
	CString buf;
	CString stat;
	CString message_id;
	CString in_reply_to;
	CString char_set;
	CString tmp;
	CStringArray header;

	CPochyApp *app = (CPochyApp *)AfxGetApp();
	CMainFrame *mf = (CMainFrame *)app->m_pMainWnd;

	// [TCY̎擾iK[ۑɁj
	size.Format("%d", g_get_file_size(org_file_path));

	//	seq must be relative path
	tmp = org_file_path;
	seq = g_get_relative_path(dst_folder_path, tmp.Left(tmp.ReverseFind('\\')));
	seq += tmp.Mid(tmp.ReverseFind('\\'));

	// [wb_odecodeKvȃwb_擾
	g_get_header(org_file_path, header);
	CHeaderInfo hi;
	hi.DoIt(header);

	subject = hi.GetSubject();
	subject.TrimRight("\r\n");
	if(subject.GetLength() > LISTCTRL_BUF_LENGTH){
		subject = subject.Left(LISTCTRL_BUF_LENGTH);
	}

	to = hi.GetTo();
	to.TrimRight("\r\n");
	if(to.GetLength() > LISTCTRL_BUF_LENGTH){
		to = to.Left(LISTCTRL_BUF_LENGTH);
	}

	from = hi.GetFrom();
	from.TrimRight("\r\n");

	message_id = hi.GetMsgID();
	message_id.TrimRight("\r\n");

	in_reply_to = hi.GetInReplyTo();
	in_reply_to.TrimRight("\r\n");

	char_set = hi.GetCharset();
	char_set.TrimRight("\r\n");

	// list̐ݒ
	path.Format("%s\\list", dst_folder_path);
	FILE *file = fopen(path, "ab");
	if(what_kind_box == SMRY_COLUMN_TO){
		fprintf(file, "%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\r\n",
			size, subject, to, date, seq, stat, message_id, in_reply_to, char_set);
	}else{
		fprintf(file, "%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\x02%s\r\n",
			size, subject, from, date, seq, stat, message_id, in_reply_to, char_set);
	}
	fclose(file);

	// ۑ悪ݕ\ĂtH_Ȃȉs
	if(g_string_compare_no_case(m_path, g_get_complete_path(dst_folder_path))){
		SLISTSTACK* data = new SLISTSTACK;

		data->m_str1 = size;
		data->m_str2 = subject;
		// ۑɂăT}[ɕ\񂪈Ⴄ
		if(what_kind_box == SMRY_COLUMN_TO)
			data->m_str3 = to;
		else
			data->m_str3 = from;
		data->m_str4 = date;
		data->m_str5 = seq;
		data->m_str6 = stat;
		data->m_str7 = message_id;
		data->m_str8 = in_reply_to;
		data->m_str9 = char_set;

		AddList(data);
		if(m_index != -1){
			m_index++;
		}
		// ǃ[̐m_unread++
		if(stat.Find("N") != -1){
			CString unread;
			unread.Format(" %d  [ %d", ++m_unread, m_stack_num);
			mf->SetStatusBarText(2, unread);
		}
	}

//	SetSortRequired(dst_folder_path, true);
	return TRUE;
}

// [MXbh̃R}h(march 9th, 2004 by color)
LRESULT CSummaryView::OnSendMailThreadCommand(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
	case SDMTC_SORT_WITH_REQUIRED_CHECK:
		SortWithRequiredCheck();
		break;

	default:
		break;
	}

	return 0;
}

BOOL CSummaryView::GetStatusChanged()
{
	return m_status_changed;
}

void CSummaryView::SetStatusChanged(BOOL status)
{
	m_status_changed = status;
}


int CSummaryView::GetStackNum()
{
	return m_stack_num;
}

void CSummaryView::SetStackNum(int stack_num)
{
	m_stack_num = stack_num;
}

int CSummaryView::GetIndex()
{
	return this->m_index ;
}

void CSummaryView::SetIndex(int index)
{
	this->m_index = index;
}

